local AddonName, CAGI = ...

-- Config Panel Text Strings
CAGI.Text={
Title = "Come And Get It",
TitleSub = "Change how the add on behaves by setting the options below",
Enable = "Enable the Add On to function",
Debug = "Enable Debug messages",
Serious = "Enable Serious/Strict announcements",
Solo = "Enable announcements to yourself",
Opp = "Enable announcing opposing side in BGs",
RaidWarning = "Enable announcing to RW if you can",
Mammoths = "Enable announcing of Traveler's Tundra Mammoths",
Links = "Display links of detected items instead of just text",
}

-- Bill's Utils
local ChkBoxSave = BillsUtils.ChkBoxSave
local ChkBox = BillsUtils.ChkBox -- function( Last , Prefix, Name, Parent, Click, TextTable )
local CheckClick = BillsUtils.CheckClick

BillsUtils.Locals[#BillsUtils.Locals +1] = function ()
	ChkBoxSave = BillsUtils.ChkBoxSave
	ChkBox = BillsUtils.ChkBox -- function( Last , Prefix, Name, Parent, Click, TextTable )
	CheckClick = BillsUtils.CheckClick
end


-- General Settings / functions


--Panel
CAGI.panel = CreateFrame( "Frame", "CAGIConfig", UIParent )
local me = CAGI.panel
me:SetScript("OnLoad", function()
	me.init()
end)


me.name = "ComeAndGetIt"

local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13

-- Pane title
	local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
	Title:SetPoint( "TOPLEFT", 16, -16 )
	Title:SetText( CAGI.Text.Title )
	local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
	SubText:SetPoint( "RIGHT", -32, 0 )
	SubText:SetHeight( 32 )
	SubText:SetJustifyH( "LEFT" )
	SubText:SetJustifyV( "TOP" )
	SubText:SetText( CAGI.Text.TitleSub )
	local last = SubText
	
	local Command = {"Enable", "Debug", "Serious", "Solo", "Opp", "RaidWarning", "Mammoths", "Links"}
	for x = 1, #Command do
		me[Command[x]] = ChkBox( last, "CAGI_Cfg", Command[x], me, CheckClick, CAGI.Text)
		last = me[Command[x]]
	end
	
	
--	End of frame
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- X  Init / Reset the config panel to match current settings                                                     X
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--


me.Init = function(...)
	local setting = CAGI_Settings
	local me = CAGI.panel
	local Command = {"Enable", "Debug", "Serious", "Solo", "Opp", "RaidWarning", "Mammoths", "Links"}
	for x = 1, #Command do
		me[Command[x]]:SetChecked( setting[Command[x]] )
	end
end

-- Reset config panel and settings to DEFAULT
me.Reset = function(...)
	local def = CAGI_Defaults
	local cur = CAGI_Settings
	local Command = {"Enable", "Debug", "Serious", "Solo", "Opp", "RaidWarning", "Mammoths", "Links"}
	for x = 1, #Command do
		cur[Command[x]] = def[Command[x]]
	end
	me.Init()
end



me.refresh = function(self)
	me.Init()
end

me.default = function (self)
	me.Reset()
end

me.cancel = function (self)
	me.Init()
end


-- Save settings from config panel
me.okay = function(self)
	local setting = CAGI_Settings
	local Command = {"Enable", "Debug", "Serious", "Solo", "Opp", "RaidWarning", "Mammoths", "Links"}
	for x = 1, #Command do
		ChkBoxSave( me , Command[x], setting)
	end
end

-- Register the config panel
InterfaceOptions_AddCategory( me )

